from direct.showbase.ShowBase import ShowBase
from panda3d.core import *


class Main(ShowBase):
    def __init__(self):
        ShowBase.__init__(self)
        base.setBackgroundColor(0, 0, 0, 0)

        render.setShaderAuto()

        model = loader.loadModel("model/model")
        model.reparentTo(render)
        model.setHpr(0,90,0)

        base.cam.setPos(0,-10,0)
        
        # Setting the first diffuse tex:
        ts_diffuse1 = TextureStage("d1")
        ts_diffuse1.setCombineRgb(TextureStage.CMReplace, TextureStage.CSTexture, TextureStage.COSrcColor)
        ts_diffuse1.setSort(10)

        tex_diffuse1 = loader.loadTexture("model/tex/tex1_RGB.png")

        model.setTexture(ts_diffuse1, tex_diffuse1)

        ts_diffuse1.setSavedResult(True)

        # Setting the alpha tex which blends the textures
        ts_alpha_blend = TextureStage("a")
        '''
        With the next line commented (CombineRgb...), 1.9.4. still works, 1.10 crashes
        '''
        ts_alpha_blend.setCombineRgb(TextureStage.CMReplace, TextureStage.CSTexture, TextureStage.COSrcColor)
        ts_alpha_blend.setCombineAlpha(TextureStage.CMReplace, TextureStage.CSTexture, TextureStage.COSrcAlpha)
        ts_alpha_blend.setSort(20)
        ts_alpha_blend.setTexcoordName("UVMap.001")

        tex_alpha_blend = loader.loadTexture("model/tex/blend_A.png")
        tex_alpha_blend.setFormat(tex_alpha_blend.FAlpha)

        model.setTexture(ts_alpha_blend, tex_alpha_blend)

        # Setting the second diffuse tex:
        ts_diffuse2 = TextureStage("d2")
        ts_diffuse2.setCombineRgb(TextureStage.CMInterpolate,
                                  TextureStage.CSTexture, TextureStage.COSrcColor,
                                  TextureStage.CSLastSavedResult, TextureStage.COSrcColor,
                                  TextureStage.CSPrevious, TextureStage.COSrcAlpha)
        ts_diffuse2.setSort(30)
        

        tex_diffuse2 = loader.loadTexture("model/tex/tex2_RGB.png")

        model.setTexture(ts_diffuse2, tex_diffuse2)
        
        

Main = Main()

Main.run()

